// Java-Soundmodul by uja 26.10.07
// Generierung my_sound=new sound(ressourcenpfad,wavliste);
// Aufruf: my_sound.play_sound(nr);

package gamelib;
import java.io.*;
import javax.sound.sampled.*;

/**
Diese Klasse stellt unproblematisch gepufferte Sounds zur Verfuegung.
Sie ist optimiert fuer kurze Effekt-Sounds, da sie die ganzen Sounds im Puffer haelt.
Zur Zeit ist diese Klasse nur mit WAV-Files getestet. Die Sounds sollten zweckmaessigerweise in einem bestimmten Pfad innerhalb eines Ressourcenfiles (JAR) liegen, 
@author uja
@version 20071223
*/

public class sound
{
  Clip[] saund; // Sound-Effekt-Puffer

/** Klasse, um gepufferte Sounds bereitzustellen und abzuspielen.
@param pfad Pfad zu der Soundsammlung
@param waves Sounddateien als String-Vektor
*/
  public sound(String pfad, String[] waves)
  { saund=new Clip[waves.length];
    for (int i=0; i<waves.length; i++)
    { try
      { AudioInputStream ais=AudioSystem.getAudioInputStream(this.getClass().getResourceAsStream(pfad+waves[i]));
        AudioFormat af = ais.getFormat();
       // Clip erzeugen und oeffnen, dabei in Frames umrechnen
        DataLine.Info info = new DataLine.Info(Clip.class,af,((int) ais.getFrameLength()*af.getFrameSize()) );
        saund[i] = (Clip)AudioSystem.getLine(info);
        // ready for use:
        saund[i].open(ais);
      }
      catch (Exception e) { System.out.println("Sound-error: "+pfad+waves[i]); }
    }
  }

/** Sound mit bestimmter Id abspielen. 
@param nr Sound-Id in dem dem Konstruktor uebergebenen Vektor
*/
  public void play_sound(int nr) { saund[nr].setFramePosition(0); saund[nr].start(); }

/** Notbremse, falls der Sound mit der Id den Ablauf stoert (vgl.MIDI-Haenger).
@param nr Sound-Id des haengengebliebenen Sounds
*/
  public void stop_sound(int nr) { saund[nr].stop(); }

/** Freigabe aller Sound-Ressourcen. Freigabe der Ressourcen, empfehlenswert zu Programmende. */
  public void close_soundall()
  { try { for (int i=0; i<saund.length; i++) saund[i].close(); }
    catch(Exception e) { }
  }

} 