// ===============================================================================================
package schlangengrube;

import javax.swing.*;
import javax.swing.JCheckBoxMenuItem;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.Hashtable;

import gamelib.loadsave;
import gamelib.hiscore;
import gamelib.sound;
// -----------------------------------------------------------------------------

public class main
{
  final static String kenn="schlangengrube";
  final static String datenpfad=kenn+"/data/"; // Jar-Ressourcen
  final static String configfile="game.ini";   // Muster: Schluessel=Wert, oder nur Schluessel fuer bool=true

  final static String commands[] ={ "neu","laden","speichern","quit","pause","sound","saveopt",
                                    "hiscore","hireset","hilfe","about" };
  final static String waves[]    ={ "schuss.wav","treffer.wav","zusammenfallen.wav",
                                    "schlange_getroffen.wav","levelup.wav","gameover.wav","explo.wav" };

  // Sprachdefinitionen:
  static String gname="Schlangengrube";
  static String hscfile="hiscore.csv",gamefile="game.sav",lang="en"; // en oder deu, wird aus game.ini ausgelesen
  static Hashtable<String,String> langdef=new Hashtable<String,String>(); // Uebersetzungstabellen
  static String hilfetext[]; // Hilfetexte

  static hiscore   hsc;     // Pfad und Datei aus configfile
  static loadsave  fh       =new loadsave();
  static sound     my_sound =new sound("/"+kenn+"/sounds/",waves);
  static main      self     =new main();
  static spiel     my_spiel =new spiel(self);
  static spielfeld gamepanel=new spielfeld(self); // als parent uebergeben

 // vom Spieler gesteuerte Menupunkte:
  static boolean mit_sound=false,pausiert=false;
  static JCheckBoxMenuItem sou_on;
  static JCheckBoxMenuItem pause;

 // Listeners:
  static ActionListener alist=new ActionListener() { public void actionPerformed(ActionEvent e) { buttonklick(e); } };
  static MouseAdapter mausdap=new MouseAdapter() { public void mousePressed(MouseEvent e){ klick(e.getX(),e.getY()); } };
  static MouseMotionAdapter mausdapm=new MouseMotionAdapter()
  { public void mouseMoved(MouseEvent e) { mausover(e.getX(),e.getY()); } };


// Konstruktor: ---------------------------------------------------------------------------------------------------------
  public static void main(String[] args) 
  { javax.swing.SwingUtilities.invokeLater(new Runnable()
    { public void run() { load_config(); init_gui(); set_buttons(); my_spiel.set_sound(mit_sound); } } ); 
  }

// slots:
  static String get_kennung()   { return kenn; }
  static String get_spielname() { return gname; }
  static String get_lang(String t) { return langdef.get(t); }
  static void popup(String t) { JOptionPane.showMessageDialog(null,t,"Info:",JOptionPane.INFORMATION_MESSAGE); }

// ----------------------------------------------------------------------------------------------------------------
// Sprachmodule, Einstellungen und Spiel laden/speichern:
// ----------------------------------------------------------------------------------------------------------------
  static void load_config()
  { int i;
    String rec[]=fh.get_filelines(configfile);
    String temp[]=new String[2];
    for (i=0; i<rec.length; i++)
    { temp=rec[i].split("=");
      if (temp[0].equals("lang")) lang=temp[1];
      else if (temp[0].equals("soundon")) mit_sound=(Integer.parseInt(temp[1])>0);
      else if (temp[0].equals("hiscore")) hscfile=temp[1];
      else if (temp[0].equals("gamestore")) gamefile=temp[1];
    }
    rec=fh.get_ressourcelines("/"+datenpfad+"lang_"+lang+".def");
    for (i=0; i<rec.length; i++)
    { temp=rec[i].split("=");
      langdef.put(temp[0],temp[1]);
    }
    hilfetext=fh.get_ressourcelines("/"+datenpfad+"hilfe_"+lang+".txt");
    hsc=new hiscore(hscfile,langdef.get("EINTRAG"),langdef.get("ZU_WENIG"));
    gname=langdef.get("SCHLANGENG");
  }

  static void save_options()
  { String raus="lang="+lang+"\n";
    if (mit_sound)  raus=raus+"soundon=1\n"; else raus=raus+"soundon=0\n";
    raus=raus+"hiscore="+hscfile+"\n";
    raus=raus+"gamestore="+gamefile+"\n";
    fh.set_fileinhalt(configfile,raus);
  }

  static int[] loadgame()
  { String rec[]=fh.get_filelines(gamefile);
    rec=rec[0].split(";");
    int[] p= { Integer.parseInt(rec[0]),Integer.parseInt(rec[1]) };
    return p;
  }

  static void savegame(int lv,int pkt) { fh.set_fileinhalt(gamefile,""+lv+";"+pkt+"\n"); }

// ------------------------------------------------------------------------------------------------------------------
// Hauptfenster und Menus:
// ------------------------------------------------------------------------------------------------------------------
  static void init_gui()
  { JPanel mama=new JPanel(new BorderLayout());
    mama.add(gamepanel);
    JFrame frame=new JFrame(gname);
    JMenuBar my_menu=mach_menubar();
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    frame.setJMenuBar(my_menu);
    frame.setContentPane(mama);
    frame.setSize(gamepanel.sxmax,gamepanel.symax);
    gamepanel.addMouseListener(mausdap);
    gamepanel.addMouseMotionListener(mausdapm);
    frame.setVisible(true);
  }

  static JMenuBar mach_menubar()
  { JMenuBar menu=new JMenuBar();
    // Dropdown Menus Headers:
    JMenu menu0=new JMenu(langdef.get("GAME"));     menu0.setMnemonic(KeyEvent.VK_0); menu.add(menu0);
    JMenu menu1=new JMenu(langdef.get("OPTIONS"));  menu1.setMnemonic(KeyEvent.VK_1); menu.add(menu1);
    JMenu menu2=new JMenu(langdef.get("HISCORE"));  menu2.setMnemonic(KeyEvent.VK_2); menu.add(menu2);
    JMenu menu3=new JMenu(langdef.get("INFO"));     menu3.setMnemonic(KeyEvent.VK_3); menu.add(menu3);

    // Dropdown Menu 0:
    JMenuItem neu = new JMenuItem(langdef.get("NEW"),KeyEvent.VK_N);
    neu.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N,InputEvent.CTRL_MASK));
    neu.addActionListener(alist);
    neu.setActionCommand(commands[0]);
    menu0.add(neu);
    JMenuItem laden = new JMenuItem(langdef.get("LOAD"),KeyEvent.VK_L);
    laden.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_L,InputEvent.CTRL_MASK));
    laden.setActionCommand(commands[1]);
    laden.addActionListener(alist);
    menu0.add(laden);
    JMenuItem speichern = new JMenuItem(langdef.get("SAVE"),KeyEvent.VK_S);
    speichern.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S,InputEvent.CTRL_MASK));
    speichern.setActionCommand(commands[2]);
    speichern.addActionListener(alist);
    menu0.add(speichern);
    menu0.addSeparator();
    JMenuItem quit = new JMenuItem(langdef.get("QUIT"),KeyEvent.VK_Q);
    quit.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Q,InputEvent.CTRL_MASK));
    quit.addActionListener(alist);
    quit.setActionCommand(commands[3]);
    menu0.add(quit);

    // Dropdown Menu 1:
    pause=new JCheckBoxMenuItem(langdef.get("PAUSE"));
    pause.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_P,InputEvent.CTRL_MASK));
    pause.setActionCommand(commands[4]);
    pause.addActionListener(alist);
    menu1.add(pause);
    sou_on=new JCheckBoxMenuItem(langdef.get("SOUND"));
    sou_on.setActionCommand(commands[5]);
    sou_on.addActionListener(alist);
    menu1.add(sou_on);
    menu1.addSeparator();
    JMenuItem saveopt = new JMenuItem(langdef.get("SAVEOPT"));
    saveopt.addActionListener(alist);
    saveopt.setActionCommand(commands[6]);
    menu1.add(saveopt);

    // Dropdown Menu 2:
    JMenuItem showhsc = new JMenuItem(langdef.get("SHOWHSC"),KeyEvent.VK_Z);
    showhsc.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Z,InputEvent.CTRL_MASK));
    showhsc.setActionCommand(commands[7]);
    showhsc.addActionListener(alist);
    menu2.add(showhsc);
    JMenuItem res_hsc = new JMenuItem(langdef.get("RESETHSC"),KeyEvent.VK_R);
    res_hsc.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_R,InputEvent.CTRL_MASK));
    res_hsc.setActionCommand(commands[8]);
    res_hsc.addActionListener(alist);
    menu2.add(res_hsc);

    // Dropdown Menu 3:
    JMenuItem hilfe = new JMenuItem(langdef.get("HELP"),KeyEvent.VK_H);
    hilfe.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_H,InputEvent.CTRL_MASK));
    hilfe.setActionCommand(commands[9]);
    hilfe.addActionListener(alist);
    menu3.add(hilfe);
    JMenuItem about = new JMenuItem(langdef.get("ABOUT"),KeyEvent.VK_A);
    about.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_A,InputEvent.CTRL_MASK));
    about.setActionCommand(commands[10]);
    about.addActionListener(alist);
    menu3.add(about);
    return menu;
  }

  // setzt die Checkmarks entsprechend mit_sound, pausiert
  static void set_buttons()
  { sou_on.setSelected(mit_sound);
    pause.setSelected(pausiert);
  }
// ------------------------------------------------------------------------------------------------------
// ActionListeners auswerten:
// ------------------------------------------------------------------------------------------------------
  static public void buttonklick(ActionEvent e)
  { String info="Java Arcade Spiel Schlangengrube\nAuthor: uja\nVersion 1.2 (31.12.2007)";
    int kommando=-1;
    for (int i=0; i<commands.length; i++) if (commands[i] .equals(e.getActionCommand())) kommando=i;
    switch(kommando)
    { case 0: pausiert=false; my_spiel.set_pause(pausiert); gamepanel.set_screen(0); my_spiel.neu(0,0); break;
      case 1: int param[]=loadgame();
              pausiert=false; my_spiel.set_pause(pausiert); 
              gamepanel.set_screen(0);
              my_spiel.neu(param[0],param[1]);
              popup(langdef.get("LOADED"));
              break;
      case 2: gamepanel.set_screen(0);
              savegame(my_spiel.level,my_spiel.punkte0);
              popup(langdef.get("SAVED"));
              break;
      case 3: aufraeumen(); break;
      case 4: pausiert=!pausiert; my_spiel.set_pause(pausiert); gamepanel.set_screen(0); break;
      case 5: mit_sound=!mit_sound; my_spiel.set_sound(mit_sound); break;
      case 6: save_options(); popup(langdef.get("OPTSAVED")); break;
      case 7: pausiert=true; my_spiel.set_pause(pausiert); gamepanel.set_screen(1); break;
      case 8: pausiert=true; my_spiel.set_pause(pausiert); hsc.reset_hsc(); gamepanel.set_screen(1); break;
      case 9: pausiert=true; my_spiel.set_pause(pausiert); gamepanel.set_screen(2); break;
      case 10: popup(info); break;
      default: pausiert=true; my_spiel.set_pause(pausiert); gamepanel.set_screen(-1); // Titelbild
    }
    set_buttons();
  }

  static void klick(int mx,int my)    { my_spiel.klick(mx,my); }
  static void mausover(int mx,int my) { my_spiel.hover(mx,my); }
  static void aufraeumen()            { my_sound.close_soundall(); System.exit(0); }

}
