// internationale Version V. 1.2: 23.12.07, ausgelagerte Bibliotheken, javadoc-Optimierung
// ===============================================================================================
package schlangengrube;

import javax.swing.*;
import java.awt.*;
import java.awt.image.*;
import java.awt.Graphics2D.*;
import java.awt.event.*;
import javax.imageio.*;
import java.io.*;
import java.lang.Math;

/**
Threadgesteuerte Darstellung eines Zeichenbrettes, benutzt Graphics2D.
Framerate ist derzeit 20ms.
Zum Clonen und Modifizieren gedacht
Die aufrufende Klasse main wird als parent uebergeben: main beherbergt das Sprachmodul und andere Listen
und regelt die Kommunikation mit anderen Programmteilen.
Wg. Geschwindigkeitsvorteilen bei den Sprites wird ein Pointer auf die Klasse spiel erzeugt (Kleiner Dienstweg)
@author uja
@version 20071224
@see java.awt.Graphics2D
@see java.awt.image
@see javax.imageio
*/

class spielfeld extends JPanel  implements Runnable
{
  // alle "interessanten" Variable muessen statisch sein, sonst Nullpointer-Wxception!
  static final int cmax=10;   // 7 verschiedene Kugeln+3 Explophasen
  static final int fmax=6;    // 6 verschiedene Floater, neu in 1.1
  static final int bmax=4;    // 4 Hintergrundbilder
  static final int sxmax=640; // Screengroesse ab 1.1
  static final int symax=480; // Screengroesse ab 1.1
  static final Color color_vg=new Color(240,240,64,255);  // gelbe Schrift
  static final Color color_bg=new Color(48,16,0,127);     // brauner Hintergrund
  static final Color color_rahmen=new Color(0,127,0,191); // gruener Rahmen
  static final Font font=new Font("SansSerif",Font.BOLD,14);
  final FontMetrics metrics = getFontMetrics(font);

  Thread refresh=null;
  static int timetic=35;
  long time2,time1=System.currentTimeMillis(); // Timer zu Testzwecken

  String bildpfad;
  Image titelima,bgima,pause,gover,schlange1,schlange2,kroete,shooter,shadow;
  Image ima[]  =new Image[cmax]; // Kugeln
  Image fima[] =new Image[fmax]; // neu in 1.1
  // Vorbereitung des levels:
  BufferedImage bima=new BufferedImage(sxmax,symax,BufferedImage.TYPE_INT_ARGB);
  Graphics gb=bima.getGraphics();

  int aktscreen=-1;                            // Titelbild
  int levelshown=-1;                           // kein level geladen
  main mama;    // parent
  spiel p_game; // Pointer auf Class Spiel, wird ueber die mama besorgt

/** Erzeugen eines Swing-kompatiblen Grafik-Canvasses.
@param parent aufrufende Klasse vom Typ main (Application)
*/
  public spielfeld(main parent)
  { mama=parent;
    p_game=mama.my_spiel;
    bildpfad="/"+mama.get_kennung()+"/images/";
    init_data();
  }

/** Refresh-Loop */
  public void run()
  { while (refresh!=null)
    { repaint();
      try { Thread.sleep(timetic); }
      catch (InterruptedException e) { break; }
    }
  }

  // slots:
/** Refresh-Notbremse Variante 1 */
  public void stop()    { refresh=null; }
/** Refresh-Notbremse Variante 2 */
  public void destroy() { stop(); }

/** Wechsel zwischen Titelbild, Spielbrett, Hiscore und Hilfetexte */
  public void set_screen(int nr) { aktscreen=nr; }
// ============================================================================================================

  void prepare_levelima()
  { int i,j,k;
    bgima=hole_bild(bildpfad+"bgr"+(p_game.level%bmax)+".jpg");
    gb.drawImage(bgima,0,0,sxmax,symax,null);
    // Pfad zeichnen, offset 4px:
    if (p_game.maxcount>0)
    { for (i=0; i<p_game.maxcount; i++) gb.drawImage(shadow,p_game.koo[i][0]-4,p_game.koo[i][1]-4,null);
      levelshown=p_game.level;
    }
    else levelshown=-1;
  }

  void init_data()
  { int i;
    titelima=hole_bild(bildpfad+"titelbild.png");
    shadow=hole_bild(bildpfad+"shadow.png");
    pause=hole_bild(bildpfad+"pause.png");
    gover=hole_bild(bildpfad+"gover.png");
    shooter=hole_bild(bildpfad+"shooter.png");
    schlange1=hole_bild(bildpfad+"schlange1.png");
    schlange2=hole_bild(bildpfad+"schlange2.png");
    kroete=hole_bild(bildpfad+"schildkroete.png");
    bgima=hole_bild(bildpfad+"bgr0.jpg");
    for (i=0; i<cmax; i++) ima[i]=hole_bild(bildpfad+"k24_"+i+".png");
    for (i=0; i<fmax; i++) fima[i]=hole_bild(bildpfad+"floater_"+i+".png");
    refresh=new Thread(this);
    refresh.start();
  }

  public void paintComponent(Graphics g)
  { g.setColor(Color.black);
    g.fillRect(0,0,sxmax,symax);
    g.drawImage(bgima,0,0,sxmax,symax,null);
    g.setFont(font);
    switch (aktscreen)
    { case 0: if (levelshown!=p_game.level) prepare_levelima(); mach_spielfeld(g); break;
      case 1: zeige_hsc(g);   break;
      case 2: zeige_hilfe(g); break;
      default: zeige_titel(g);
    }
 //   time2=System.currentTimeMillis(); System.out.println((time2-time1)+"ms"); time1=time2;
  }

  Image hole_bild(String filnam)
  { Image ima=null;
    try { ima=ImageIO.read(getClass().getResource(filnam)); }
    catch(IOException io) { System.out.println(filnam+" not found or valid");   }
    return ima;
  }

  void mach_spielfeld(Graphics g)
  { int i;
    String out;
    g.drawImage(bima,0,0,null);
    // Actionfeld:
    for (i=0; i<p_game.maxsprites; i++) if (p_game.kugel[i].typ>0)
     g.drawImage(ima[p_game.kugel[i].typ-1],p_game.kugel[i].x,p_game.kugel[i].y,null);
    g.drawImage(schlange1,p_game.start.x,p_game.start.y,null); // erst mal nur Kopf nach rechts
    g.drawImage(schlange2,p_game.ziel.x,p_game.ziel.y,null);
    g.drawImage(shooter,p_game.shooter.x,p_game.shooter.y,null);
    for (i=0; i<p_game.haufen.length; i++) if (p_game.haufen[i].typ>0)
     g.drawImage(kroete,p_game.haufen[i].x,p_game.haufen[i].y,null);
    for (i=0; i<p_game.floater.length; i++) if (p_game.floater[i].typ>0)
     g.drawImage(fima[p_game.floater[i].typ-1],p_game.floater[i].x,p_game.floater[i].y,null);
    if (p_game.flyer.typ>0)  g.drawImage(ima[p_game.flyer.typ-1],p_game.flyer.x,p_game.flyer.y,null);
    // Anzeigen:
    if (p_game.gover) g.drawImage(gover,64,120,null); else if (p_game.pausiert) g.drawImage(pause,64,120,null);
    out=mama.get_lang("LEVEL")+": "+p_game.level+"  "+mama.get_lang("SCORE")+": "+p_game.punkte+"   "+p_game.messi;
    g.setColor(Color.black); g.fillRect(32,symax-80,sxmax-64,24);
    g.setFont(font); g.setColor(color_vg); g.drawString(out,64,symax-64);
  }

  void zeige_hsc(Graphics g)
  { int i,line,max=mama.hsc.get_maxeintrag();
    String out;
    g.drawImage(bgima,0,0,null);
    g.setColor(color_bg); line=96; for (i=0; i<max; i++) { g.fillRect(32,line-18,sxmax-64,20); line=line+24; }
    g.setColor(color_rahmen); line=96; for (i=0; i<max; i++) { g.drawRect(32,line-18,sxmax-64,20); line=line+24; }
    g.setColor(color_vg); g.drawString(mama.get_lang("HISCORE"),64,32); g.drawLine(32,64,sxmax-64,64);
    line=96;
    for (i=0; i<max; i++)
    { g.drawString(""+(i+1)+". "+mama.hsc.get_snamen(i),64,24*i+96);
      out=""+mama.hsc.get_punkte(i); g.drawString(out,5*sxmax/8-metrics.stringWidth(out),line);
      out=mama.hsc.get_datum(i);     g.drawString(out,sxmax-64-metrics.stringWidth(out),line);
      line=line+24;
    }
  }

  void zeige_hilfe(Graphics g)
  { g.drawImage(bgima,0,0,null);
    g.setColor(color_bg);     g.fillRect(24,64,sxmax-48,256);
    g.setColor(color_rahmen); g.drawRect(24,64,sxmax-48,256);
    g.setColor(Color.yellow); g.drawString(mama.get_lang("HELP"),64,32);
    g.drawLine(32,48,sxmax-64,48);
    for (int i=0; i<mama.hilfetext.length; i++) g.drawString(mama.hilfetext[i],32,96+16*i);
  }

  void zeige_titel(Graphics g)
  { g.drawImage(titelima,0,0,null);
    g.setColor(color_bg);
    g.fillOval(144,192,320,48);
    g.setColor(color_rahmen);
    g.drawOval(144,192,320,48);
    g.setColor(Color.yellow);
    g.drawString(mama.get_lang("NEW")+": Ctrl-N",224,208);
    g.drawString(mama.get_lang("HELP")+": Ctrl-H",224,232);
  }


}